// ============================================================================
// ==                                                                        ==
// == AMDiS - Adaptive multidimensional simulations                          ==
// ==                                                                        ==
// ============================================================================
// ==                                                                        ==
// ==  TU Dresden                                                            ==
// ==                                                                        ==
// ==  Institut für Wissenschaftliches Rechnen                               ==
// ==  Zellescher Weg 12-14                                                  ==
// ==  01069 Dresden                                                         ==
// ==  germany                                                               ==
// ==                                                                        ==
// ============================================================================
// ==                                                                        ==
// ==  https://gforge.zih.tu-dresden.de/projects/amdis/                      ==
// ==                                                                        ==
// ============================================================================

/** \file MeshManipulation.h */

#ifndef AMDIS_MESHMANIPULATION_H
#define AMDIS_MESHMANIPULATION_H

#include <set>
#include <map>

#include "AMDiS_fwd.h"

namespace AMDiS {

  class MeshManipulation {
  public:
    MeshManipulation(Mesh *m)
      : mesh(m)
    {}

    void deleteDoubleDofs(std::set<MacroElement*>& newMacroEl);

  private:
    void deleteDoubleDofs(std::map<int, MacroElement*>& leafInMacroEl,
			  std::set<MacroElement*>& newMacroEl,
			  int mode);

  private:
    Mesh *mesh;
  };

}

#endif

